#include <unistd.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <string.h>
#define BUFLEN 200
#define MAXSONS 6

int main(int argc, char *argv[]) 
{ 
    int sock; 
    int i, nread; 
    struct sockaddr_in addr; 
    char buffer[BUFLEN];
    int n_sons;

    if(argc <1){
	printf("Daytime Client\nUsage: %s <daytime_server_ip>\n",argv[0]);
	}

    /* create socket */ 
    if ( (sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0) { 
        perror("Socket creation error"); 
        return -1; 
    } 
    /* initialize address */ 
    memset((void *) &addr, 0, sizeof(addr));    /* clear server address */ 
    addr.sin_family = AF_INET;                  /* address type is INET */ 
    addr.sin_port = htons(13);                  /* daytime port is 13 */ 
    /* build address using inet_pton */ 
    if ( (inet_pton(AF_INET, argv[1], &addr.sin_addr)) <= 0) { 
        perror("Address creation error"); 
        return -1; 
    } 
    /* send request packet */
    for(){ 
    nread = sendto(sock, NULL, 0, 0, (struct sockaddr *)&addr, sizeof(addr)); 
    
    /* normal exit */ 
    return 0; 
} 
