#include <unistd.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>


int main(int argc, char *argv[]) 
{ 
    int sock; 
    int i, n=0, clilen, verbose=1; 
    struct sockaddr_in6 srvaddr,cliaddr; 
    char buffer[80]={0}; 
    time_t timeval; 

    /* create socket */ 
    if ( (sock = socket(AF_INET6, SOCK_DGRAM, 0)) < 0) { 
        perror("Socket creation error"); 
        exit(-1); 
    }
    /* initialize address */ 
    memset((void *)&srvaddr, 0, sizeof(srvaddr));     /* clear server address */ 
    srvaddr.sin6_family = AF_INET6;                  /* address type is INET */ 
    srvaddr.sin6_port = htons(13);                  /* daytime port is 13 */ 
    srvaddr.sin6_addr.s6_addr = IN6ADDR_ANY_INIT;   /* connect from anywhere */
    srvaddr.sin6_scope_id = 0;
    /* bind socket */ 
    if (bind(sock, (struct sockaddr *)&srvaddr, sizeof(srvaddr)) < 0) { 
        perror("bind error"); 
        exit(-1); 
    } 
    printf("Bound to port 13, entering daemon mode\n");
    /* daemon(1,1); */
    /* write daytime to client */ 
    while (1) {
        n = recvfrom(sock, buffer, 80, 0, (struct sockaddr *)&cliaddr, &clilen); 
        if (n < 0) { 
            perror("recvfrom error"); 
            exit(-1); 
        } 
	printf("buffer : %s \n",buffer);
        if (verbose) { 
            inet_ntop(AF_INET, &cliaddr.sin6_addr, buffer, sizeof(buffer)); 
            printf("Request from host %s, port %d\n", buffer, 
                   ntohs(cliaddr.sin_port)); 
        } 
        timeval = time(NULL); 
        snprintf(buffer, sizeof(buffer), "%.24s\r\n", ctime(&timeval)); 
        n = sendto(sock, buffer, strlen(buffer), 0, (struct sockaddr *)&cliaddr, sizeof(cliaddr)); 
        if (n < 0) { 
            perror("sendto error"); 
            exit(-1);
        } 
    } 
    /* normal exit */ 
    exit(0); 
} 
